#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int a1, b1, a2,b2;
int d;

bool check(int n, int k)
{
	if (n <= max(max(a1,a2),max(b1,b2))) return false;
	k = (k % n + n) % n;
	return (a1 == (k + d * b1 + n) % n) &&
			(a2 == (k + d * b2 + n) % n);
}

int main()
{
	cin >> d >> a1 >> b1 >> a2 >> b2;
	--a1, --a2, --b1, --b2;
	
	vector <int> n_type,
				k_type;

	k_type.push_back(a1 - d * b1);
	k_type.push_back(a2 - d * b2);
	k_type.push_back(-a1 + d * b1);
	k_type.push_back(-a2 + d * b2);

	n_type.push_back(max(max(a1,a2),max(b1,b2)) + 1);
	for (int i = 0; i < k_type.size(); ++i) {
		n_type.push_back(abs(b1 - d * a1 + k_type[i]));
		n_type.push_back(abs(b2 - d * a2 + k_type[i]));
	}
	sort(n_type.begin(), n_type.end());
	for (int n = 0; n < n_type.size(); ++n) {
		for (int k = 0; k < k_type.size(); ++k) {
			if (check(n_type[n], k_type[k])) {
				cout << n_type[n] << endl;
				return 0;
			}
		}
	}
	cout << -1 << endl;
	return 0; 
}
