//	#pragma comment(linker, "/STACK:60000000")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <string>
#include "testlib.h"

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define len(x) (int((x).size()))
#ifdef LOCALD
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) {}
#endif

#ifdef __linux__
#define I64d "%lld"
#else
#define I64d "%I64d"
#endif

typedef long long int int64;
typedef long double ext;
                                      

using namespace std;

FILE *f;
char s[3];

const int tcnt = 5;
const int in = 4;
const int aux = 3;


int cards(int i, int j){
	if (i == 1)
		return rnd.next(3) + 2;
	int mx = (1 << (i - 1));
	if (j < in) 
		return min(20, max(mx + 1 - rnd.next(aux), 2));
	else
		return min(20, max(2, rnd.next(aux) + mx + 2));		                             
}

vector<pair<int, int> > v;

int main(int argc, char *argv[])
{
	registerGen(argc, argv, 1);
	for (int i = 1; i <= 6; i++){
		for (int j = 0; j < tcnt ; j++)			
			v.pb(mp(i, cards(i, j)));						
	}
	sort(v.begin(), v.end());
	v.resize(unique(v.begin(), v.end()) - v.begin());
	while (len(v) < 30){
		int x = rnd.next(6) + 1;
		v.pb(mp(x, rnd.next(19) + 2));
	}
	while (len(v) > 30){
		int x = rnd.next(len(v));
		v.erase(v.begin() + x);
	}
	int cnt = 3;
	sort(v.begin(), v.end());
	for (int i = 0; i < len(v); i++){
			s[0] = cnt / 10 + '0';
			s[1] = cnt % 10 + '0';
			s[2] = 0;
			eprintf("%s\n", s);
			f = fopen(s, "wt");
			fprintf(f, "%d\n%d\n", v[i].fs, v[i].sc);
			fclose(f);
			cnt++;		
	}

    return 0;
}
