#include <cstdio>
using namespace std;

const int N = 30000;
int arr[N + 1];

bool is_prime(int x)
{
    if (x == 1)
        return false;
    for (int i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}

int main()
{
    int l, k;
    scanf("%d %d", &l, &k);
    for (int i = 1; i <= N; i++)
        arr[i] = is_prime(i);
    for (int i = 1; i + l <= N + 1; i++)
    {
        int S = 0;
        for (int j = i; j < i + l; j++)
            S += arr[j];
        if (S == k)
        {
            printf("%d %d\n", i, i + l - 1);
            return 0;
        }
    }
    printf("%d\n", -1);
    return 0;
}
