#include <cstdio>
#include <algorithm>
#include <iostream>

using namespace std;

const int N = 1000 * 1000 + 10;

int res[N];
int tot;
int a, b;

bool good()
{
    int ca = 0;
    int cb = 0;
    for (int i = 1; i < tot; i++)
        if (res[i - 1] < res[i])
            ca++;
        else
            cb++;
    return a == ca && b == cb;
}

const int BUF_SIZE = (int)1e7;

int d[8];
char buf[BUF_SIZE];
int len = 0;

void add_to_buffer(int x)
{
    int sz = 0;
    while (x)
    {
        d[sz++] = x % 10;
        x /= 10;
    }
    for (int i = sz - 1; i >= 0; i--)
        buf[len++] = char(d[i] + '0');
    buf[len++] = ' ';
}


int main()
{
    scanf("%d%d", &a, &b);
    tot = a + b + 1;
    for (int i = 1; i <= tot; i++)
        res[i - 1] = i;
    for (;;)
    {
        if (good())
            break;
        random_shuffle(res, res + tot);
    }
    for (int i = 0; i < tot; i++)
        add_to_buffer(res[i]);
    buf[len++] = 0;
    puts(buf);

    return 0;
}
